using System;
using System.Runtime.InteropServices;
using SDL2;
using SlatedGameToolkit.Framework.Exceptions;

namespace SlatedGameToolkit.Framework.Graphics
{
    [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
    internal delegate void GLClearColour(float r, float g, float b);
    [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
    internal delegate void GLClear(GLEnums flags);
    [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
    internal delegate void GLViewport(int x, int y, int width, int height);
    [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
    internal delegate UIntPtr GLCreateShader(GLEnums type);
    [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
    internal delegate UIntPtr GLShaderSource(UIntPtr shaderHandle, uint count, string program, int[] length);
    [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
    internal delegate void GLCompileShader(UIntPtr shaderHandle);
    [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
    internal delegate void GLGetShaderLogInfo(UIntPtr shader, uint maxLength, out uint writtenLength, out string output);
    [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
    internal delegate UIntPtr GLCreateProgram();
    [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
    internal delegate UIntPtr GLDeleteProgram(UIntPtr program);
    [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
    internal delegate void GLAttachShader(UIntPtr program, UIntPtr shader);
    [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
    internal delegate void GLDetachShader(UIntPtr program, UIntPtr shader);
    [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
    internal delegate void GLDeleteShader(UIntPtr shader);
    [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
    internal delegate void GLBindAttribLocation(UIntPtr program, uint index, string name);
    [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
    internal delegate void GLGetProgramInfoLog(UIntPtr program, uint maxLength, out uint writtenLength, out string output);
    [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
    internal delegate void GLLinkProgram(UIntPtr program);
    [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
    internal delegate void GLProgramParameter(UIntPtr program, GLEnums parameterName, int value);
    [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
    internal delegate void GLUseProgram(UIntPtr program);
    [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
    internal delegate void GLGenProgramPipelines(uint size, UIntPtr[] pipelines);
    [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
    internal delegate void GLDeleteProgramPipelines(uint size, UIntPtr[] pipelines);
    [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
    internal delegate void GLBindProgramPipeline(UIntPtr pipeline);
    [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
    internal delegate void GLUseProgramStages(UIntPtr pipeline, GLEnums bitField, UIntPtr program);
    [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
    internal delegate uint GLGetError();
    [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
    internal delegate int GLGetAttribLocation(UIntPtr program, string attribName);
    [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
    internal delegate void GLBindBuffer(GLEnums target, UIntPtr buffer);
    [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
    internal delegate void GLGenBuffers(uint size, UIntPtr[] buffers);
    [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
    internal unsafe delegate void GLBufferData(GLEnums target, uint size, Array data, GLEnums usage);
    [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
    internal delegate void GLDeleteBuffers(uint size, UIntPtr[] buffers);
    [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
    internal delegate void GLVertexAttribPointer(uint index, int size, GLEnums type, bool normalized, uint stride, uint offset);
    [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
    internal delegate void GLGenVertexArrays(uint amount, UIntPtr[] arrays);
    [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
    internal delegate void GLDeleteVertexArrays(uint amount, UIntPtr[] arrays);
    [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
    internal delegate void GLBindVertexArray(UIntPtr array);
    [UnmanagedFunctionPointer(CallingConvention.Cdecl)]   
    internal delegate void GLEnableVertexAttribArray(uint attribIndex);
    [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
    internal delegate void GLDisableVertexAttribArray(uint attribIndex);
    [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
    internal delegate void GLDrawArrays(GLEnums mode, int first, uint count);
    [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
    internal delegate void GLDrawElements(GLEnums mode, uint count, int offset);
    [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
    internal delegate void GLMultiDrawArrays(GLEnums mode, int[] first, uint[] count, uint primout);
    [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
    internal delegate void GLMultiDrawElements(GLEnums mode, uint[] count, GLEnums type, IntPtr indices, int length);
    [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
    internal delegate void GLGenTextures(uint n, UIntPtr[] textureHandles);
    [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
    internal delegate void GLBindTexture(GLEnums target, UIntPtr texture);
    [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
    internal delegate void GLDeleteTextures(uint n, UIntPtr[] textureHandles);
    [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
    internal delegate void GLTexParameteri(GLEnums target, GLEnums pname, int value);
    [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
    internal delegate void GLTexParameterf(GLEnums target, GLEnums pname, float value);
    [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
    internal delegate void GLTexParameteriv(GLEnums target, GLEnums pname, int[] values);
    [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
    internal delegate void GLTexParameterfv(GLEnums target, GLEnums pname, float[] values);
    [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
    internal delegate void GLTexImage2D(GLEnums target, int level, int internalFormat, uint width, uint height, int border, GLEnums format, GLEnums type, byte[] data);
    [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
    internal delegate void GLGenerateMipMap(GLEnums target);

    internal static class GLFunctionUtils {
        public static T RetrieveGLDelegate<T>(string functionName) where T : Delegate {
            GameEngine.Logger.Debug(String.Format("Retrieving function with name: {0}", functionName));
            IntPtr functionAddress = SDL.SDL_GL_GetProcAddress(functionName);
            if (functionAddress == null) throw new FrameworkSDLException();
            return Marshal.GetDelegateForFunctionPointer<T>(functionAddress);
        }
    }
}