
using System;
using System.Numerics;

namespace SlatedGameToolkit.Framework.Graphics.Meshes
{
    public interface IMeshable
    {

        /// <summary>
        /// Each value in the array represents a 3D coordinate for the vertex, as well as a 2D texture coordinate.
        /// </summary>
        /// <value></value>
        ValueTuple<Vector3, Vector2>[] Vertices { get; }

        /// <summary>
        /// Returns indicies representing the vertices to use to create the mesh.
        /// </summary>
        /// <value>unsigned integers that are the indices of the vertices to use.</value>
        uint[] Elements { get; }
    }
}