using SlatedGameToolkit.Framework.Exceptions;

namespace SlatedGameToolkit.Framework.Graphics.Shaders
{
    public class GLFragmentShader : GLShader {

        /// <summary>
        /// Creates an OpenGL fragment shader.
        /// </summary>
        /// <param name="shader">A string representing the GLSL code to run.</param>
        public GLFragmentShader(string shader) : base() {
            Handle = createShader(GLEnums.GL_FRAGMENT_SHADER);
            shaderSource(Handle, 1, shader, null);
            compileShader(Handle);
            uint logLength;
            string shaderLog;
            getShaderLogInfo(Handle, 1024, out logLength, out shaderLog);
            if (logLength > 0) {
                Dispose();
                throw new OpenGLException(shaderLog);
            }
            OpenGLErrorException.CheckGLErrorStatus();
        }
    }
}