using System;

namespace SlatedGameToolkit.Framework.Graphics.Textures
{
    public class Texture : IDisposable
    {
        private readonly GLTexture2DSet glTexture2DSet;
        private readonly uint index;

        public Texture(GLTexture2DSet set, uint index) {
            this.glTexture2DSet = set;
            this.index = index;
        }

        public Texture(TextureData textureData, bool linear = true, bool mipmap = true) {
            TextureData[] textureDatas = new TextureData[] {textureData};
            this.glTexture2DSet = new GLTexture2DSet(textureDatas, linear, mipmap);
            this.index = 0;
        }

        public void Use() {
            this.glTexture2DSet.Bind(index);
        }

        public void Dispose()
        {
            this.glTexture2DSet.Dispose();
        }
    }
}