using System.Collections.Generic;

namespace SlatedGameToolkit.Framework.Input.Devices
{
    public delegate void keyboardUpdate(Key keys, bool pressed);
    public static class Keyboard {
        private static HashSet<Key> pressedKeys = new HashSet<Key>();

        /// <summary>
        /// Whenever a keyboard update occurs.
        /// </summary>
        public static event keyboardUpdate keyboardUpdateEvent;
        public static bool IsKeyPressed(Key key) {
            return pressedKeys.Contains(key);
        }

        internal static void OnKeyPressed(Key key) {
            pressedKeys.Add(key);
            keyboardUpdateEvent?.Invoke(key, true);
        }
        
        internal static void OnKeyReleased(Key key) {
            pressedKeys.Remove(key);
            keyboardUpdateEvent?.Invoke(key, false);
        }
    }
}