using SDL2;

namespace SlatedGameToolkit.Framework.Input
{
    public enum Key
    {
            K_RETURN = SDL.SDL_Keycode.SDLK_RETURN,
            K_ESCAPE = SDL.SDL_Keycode.SDLK_ESCAPE, // '\033'
            K_BACKSPACE = SDL.SDL_Keycode.SDLK_BACKSPACE,
            K_TAB = SDL.SDL_Keycode.SDLK_TAB,
            K_SPACE = SDL.SDL_Keycode.SDLK_SPACE,
            K_EXCLAIM = SDL.SDL_Keycode.SDLK_EXCLAIM,
            K_QUOTEDBL = SDL.SDL_Keycode.SDLK_QUOTEDBL,
            K_HASH = SDL.SDL_Keycode.SDLK_HASH,
            K_PERCENT = SDL.SDL_Keycode.SDLK_PERCENT,
            K_DOLLAR = SDL.SDL_Keycode.SDLK_DOLLAR,
            K_AMPERSAND = SDL.SDL_Keycode.SDLK_AMPERSAND,
            K_QUOTE = SDL.SDL_Keycode.SDLK_QUOTE,
            K_LEFTPAREN = SDL.SDL_Keycode.SDLK_KP_LEFTPAREN,
            K_RIGHTPAREN = SDL.SDL_Keycode.SDLK_RIGHTPAREN,
            K_ASTERISK = SDL.SDL_Keycode.SDLK_ASTERISK,
            K_PLUS = SDL.SDL_Keycode.SDLK_PLUS,
            K_COMMA = SDL.SDL_Keycode.SDLK_COMMA,
            K_MINUS = SDL.SDL_Keycode.SDLK_MINUS,
            K_PERIOD = SDL.SDL_Keycode.SDLK_PERIOD,
            K_SLASH = SDL.SDL_Keycode.SDLK_SLASH,
            K_0 = SDL.SDL_Keycode.SDLK_0,
            K_1 = SDL.SDL_Keycode.SDLK_1,
            K_2 = SDL.SDL_Keycode.SDLK_2,
            K_3 = SDL.SDL_Keycode.SDLK_3,
            K_4 = SDL.SDL_Keycode.SDLK_4,
            K_5 = SDL.SDL_Keycode.SDLK_5,
            K_6 = SDL.SDL_Keycode.SDLK_6,
            K_7 = SDL.SDL_Keycode.SDLK_7,
            K_8 = SDL.SDL_Keycode.SDLK_8,
            K_9 = SDL.SDL_Keycode.SDLK_9,
            K_COLON = SDL.SDL_Keycode.SDLK_COLON,
            K_SEMICOLON = SDL.SDL_Keycode.SDLK_SEMICOLON,
            K_LESS = SDL.SDL_Keycode.SDLK_LESS,
            K_EQUALS = SDL.SDL_Keycode.SDLK_EQUALS,
            K_GREATER = SDL.SDL_Keycode.SDLK_GREATER,
            K_QUESTION = SDL.SDL_Keycode.SDLK_QUESTION,
            K_AT = SDL.SDL_Keycode.SDLK_AT,
            /*
            Skip uppercase letters
            */
            K_LEFTBRACKET = SDL.SDL_Keycode.SDLK_LEFTBRACKET,
            K_BACKSLASH = SDL.SDL_Keycode.SDLK_BACKSLASH,
            K_RIGHTBRACKET = SDL.SDL_Keycode.SDLK_RIGHTBRACKET,
            K_CARET = SDL.SDL_Keycode.SDLK_CARET,
            K_UNDERSCORE = SDL.SDL_Keycode.SDLK_UNDERSCORE,
            K_BACKQUOTE = SDL.SDL_Keycode.SDLK_BACKQUOTE,
            K_a = SDL.SDL_Keycode.SDLK_a,
            K_b = SDL.SDL_Keycode.SDLK_b,
            K_c = SDL.SDL_Keycode.SDLK_c,
            K_d = SDL.SDL_Keycode.SDLK_d,
            K_e = SDL.SDL_Keycode.SDLK_e,
            K_f = SDL.SDL_Keycode.SDLK_f,
            K_g = SDL.SDL_Keycode.SDLK_g,
            K_h = SDL.SDL_Keycode.SDLK_h,
            K_i = SDL.SDL_Keycode.SDLK_i,
            K_j = SDL.SDL_Keycode.SDLK_j,
            K_k = SDL.SDL_Keycode.SDLK_k,
            K_l = SDL.SDL_Keycode.SDLK_l,
            K_m = SDL.SDL_Keycode.SDLK_m,
            K_n = SDL.SDL_Keycode.SDLK_n,
            K_o = SDL.SDL_Keycode.SDLK_o,
            K_p = SDL.SDL_Keycode.SDLK_p,
            K_q = SDL.SDL_Keycode.SDLK_q,
            K_r = SDL.SDL_Keycode.SDLK_r,
            K_s = SDL.SDL_Keycode.SDLK_s,
            K_t = SDL.SDL_Keycode.SDLK_t,
            K_u = SDL.SDL_Keycode.SDLK_u,
            K_v = SDL.SDL_Keycode.SDLK_v,
            K_w = SDL.SDL_Keycode.SDLK_w,
            K_x = SDL.SDL_Keycode.SDLK_x,
            K_y = SDL.SDL_Keycode.SDLK_y,
            K_z = SDL.SDL_Keycode.SDLK_z,

            K_CAPSLOCK = SDL.SDL_Keycode.SDLK_CAPSLOCK,

            K_F1 = SDL.SDL_Keycode.SDLK_F1,
            K_F2 = SDL.SDL_Keycode.SDLK_F2,
            K_F3 = SDL.SDL_Keycode.SDLK_F3,
            K_F4 = SDL.SDL_Keycode.SDLK_F4,
            K_F5 = SDL.SDL_Keycode.SDLK_F5,
            K_F6 = SDL.SDL_Keycode.SDLK_F6,
            K_F7 = SDL.SDL_Keycode.SDLK_F7,
            K_F8 = SDL.SDL_Keycode.SDLK_F8,
            K_F9 = SDL.SDL_Keycode.SDLK_F9,
            K_F10 = SDL.SDL_Keycode.SDLK_F10,
            K_F11 = SDL.SDL_Keycode.SDLK_F11,
            K_F12 = SDL.SDL_Keycode.SDLK_F12,

            K_PRINTSCREEN = SDL.SDL_Keycode.SDLK_PRINTSCREEN,
            K_SCROLLLOCK = SDL.SDL_Keycode.SDLK_SCROLLLOCK,
            K_PAUSE = SDL.SDL_Keycode.SDLK_PAUSE,
            K_INSERT = SDL.SDL_Keycode.SDLK_INSERT,
            K_HOME = SDL.SDL_Keycode.SDLK_HOME,
            K_PAGEUP = SDL.SDL_Keycode.SDLK_PAGEUP,
            K_DELETE = SDL.SDL_Keycode.SDLK_DELETE,
            K_END = SDL.SDL_Keycode.SDLK_END,
            K_PAGEDOWN = SDL.SDL_Keycode.SDLK_PAGEDOWN,
            K_RIGHT = SDL.SDL_Keycode.SDLK_RIGHT,
            K_LEFT = SDL.SDL_Keycode.SDLK_LEFT,
            K_DOWN = SDL.SDL_Keycode.SDLK_DOWN,
            K_UP = SDL.SDL_Keycode.SDLK_UP,

            K_NUMLOCKCLEAR = SDL.SDL_Keycode.SDLK_NUMLOCKCLEAR,
            K_KP_DIVIDE = SDL.SDL_Keycode.SDLK_KP_DIVIDE,
            K_KP_MULTIPLY = SDL.SDL_Keycode.SDLK_KP_MULTIPLY,
            K_KP_MINUS = SDL.SDL_Keycode.SDLK_MINUS,
            K_KP_PLUS = SDL.SDL_Keycode.SDLK_KP_PLUS,
            K_KP_ENTER = SDL.SDL_Keycode.SDLK_KP_ENTER,
            K_KP_1 = SDL.SDL_Keycode.SDLK_KP_1,
            K_KP_2 = SDL.SDL_Keycode.SDLK_KP_2,
            K_KP_3 = SDL.SDL_Keycode.SDLK_KP_3,
            K_KP_4 = SDL.SDL_Keycode.SDLK_KP_4,
            K_KP_5 = SDL.SDL_Keycode.SDLK_KP_5,
            K_KP_6 = SDL.SDL_Keycode.SDLK_KP_6,
            K_KP_7 = SDL.SDL_Keycode.SDLK_KP_7,
            K_KP_8 = SDL.SDL_Keycode.SDLK_KP_8,
            K_KP_9 = SDL.SDL_Keycode.SDLK_KP_9,
            K_KP_0 = SDL.SDL_Keycode.SDLK_KP_0,
            K_KP_PERIOD = SDL.SDL_Keycode.SDLK_KP_0,

            K_APPLICATION = SDL.SDL_Keycode.SDLK_APPLICATION,
            K_POWER = SDL.SDL_Keycode.SDLK_POWER,
            K_KP_EQUALS = SDL.SDL_Keycode.SDLK_EQUALS,
            K_F13 = SDL.SDL_Keycode.SDLK_F13,
            K_F14 = SDL.SDL_Keycode.SDLK_F14,
            K_F15 = SDL.SDL_Keycode.SDLK_F15,
            K_F16 = SDL.SDL_Keycode.SDLK_F16,
            K_F17 = SDL.SDL_Keycode.SDLK_F17,
            K_F18 = SDL.SDL_Keycode.SDLK_F18,
            K_F19 = SDL.SDL_Keycode.SDLK_F19,
            K_F20 = SDL.SDL_Keycode.SDLK_F20,
            K_F21 = SDL.SDL_Keycode.SDLK_F21,
            K_F22 = SDL.SDL_Keycode.SDLK_F22,
            K_F23 = SDL.SDL_Keycode.SDLK_F23,
            K_F24 = SDL.SDL_Keycode.SDLK_F24,
            K_EXECUTE = SDL.SDL_Keycode.SDLK_EXECUTE,
            K_HELP = SDL.SDL_Keycode.SDLK_HELP,
            K_MENU = SDL.SDL_Keycode.SDLK_MENU,
            K_SELECT = SDL.SDL_Keycode.SDLK_SELECT,
            K_STOP = SDL.SDL_Keycode.SDLK_STOP,
            K_AGAIN = SDL.SDL_Keycode.SDLK_AGAIN,
            K_UNDO = SDL.SDL_Keycode.SDLK_UNDO,
            K_CUT = SDL.SDL_Keycode.SDLK_CUT,
            K_COPY = SDL.SDL_Keycode.SDLK_COPY,
            K_PASTE = SDL.SDL_Keycode.SDLK_PASTE,
            K_FIND = SDL.SDL_Keycode.SDLK_FIND,
            K_MUTE = SDL.SDL_Keycode.SDLK_MUTE,
            K_VOLUMEUP = SDL.SDL_Keycode.SDLK_VOLUMEUP,
            K_VOLUMEDOWN = SDL.SDL_Keycode.SDLK_VOLUMEDOWN,
            K_KP_COMMA = SDL.SDL_Keycode.SDLK_COMMA,
            K_KP_EQUALSAS400 = SDL.SDL_Keycode.SDLK_KP_EQUALSAS400,

            K_ALTERASE = SDL.SDL_Keycode.SDLK_ALTERASE,
            K_SYSREQ = SDL.SDL_Keycode.SDLK_SYSREQ,
            K_CANCEL = SDL.SDL_Keycode.SDLK_CANCEL,
            K_CLEAR = SDL.SDL_Keycode.SDLK_CLEAR,
            K_PRIOR = SDL.SDL_Keycode.SDLK_PRIOR,
            K_RETURN2 = SDL.SDL_Keycode.SDLK_RETURN2,
            K_SEPARATOR = SDL.SDL_Keycode.SDLK_SEPARATOR,
            K_OUT = SDL.SDL_Keycode.SDLK_OUT,
            K_OPER = SDL.SDL_Keycode.SDLK_OPER,
            K_CLEARAGAIN = SDL.SDL_Keycode.SDLK_CLEARAGAIN,
            K_CRSEL = SDL.SDL_Keycode.SDLK_CRSEL,
            K_EXSEL = SDL.SDL_Keycode.SDLK_EXSEL,

            K_KP_00 = SDL.SDL_Keycode.SDLK_KP_00,
            K_KP_000 = SDL.SDL_Keycode.SDLK_KP_000,
            K_THOUSANDSSEPARATOR = SDL.SDL_Keycode.SDLK_THOUSANDSSEPARATOR,
            K_DECIMALSEPARATOR = SDL.SDL_Keycode.SDLK_DECIMALSEPARATOR,
            K_CURRENCYUNIT = SDL.SDL_Keycode.SDLK_CURRENCYUNIT,
            K_CURRENCYSUBUNIT = SDL.SDL_Keycode.SDLK_CURRENCYSUBUNIT,
            K_KP_LEFTPAREN = SDL.SDL_Keycode.SDLK_LEFTPAREN,
            K_KP_RIGHTPAREN = SDL.SDL_Keycode.SDLK_KP_RIGHTPAREN,
            K_KP_LEFTBRACE = SDL.SDL_Keycode.SDLK_KP_LEFTBRACE,
            K_KP_RIGHTBRACE = SDL.SDL_Keycode.SDLK_KP_RIGHTBRACE,
            K_KP_TAB = SDL.SDL_Keycode.SDLK_KP_TAB,
            K_KP_BACKSPACE = SDL.SDL_Keycode.SDLK_BACKSPACE,
            K_KP_A = SDL.SDL_Keycode.SDLK_KP_A,
            K_KP_B = SDL.SDL_Keycode.SDLK_KP_B,
            K_KP_C = SDL.SDL_Keycode.SDLK_KP_C,
            K_KP_D = SDL.SDL_Keycode.SDLK_KP_D,
            K_KP_E = SDL.SDL_Keycode.SDLK_KP_E,
            K_KP_F = SDL.SDL_Keycode.SDLK_KP_F,
            K_KP_XOR = SDL.SDL_Keycode.SDLK_KP_XOR,
            K_KP_POWER = SDL.SDL_Keycode.SDLK_KP_POWER,
            K_KP_PERCENT = SDL.SDL_Keycode.SDLK_KP_PERCENT,
            K_KP_LESS = SDL.SDL_Keycode.SDLK_KP_LESS,
            K_KP_GREATER = SDL.SDL_Keycode.SDLK_KP_GREATER,
            K_KP_AMPERSAND = SDL.SDL_Keycode.SDLK_KP_AMPERSAND,
            K_KP_DBLAMPERSAND = SDL.SDL_Keycode.SDLK_KP_DBLAMPERSAND,
            K_KP_VERTICALBAR = SDL.SDL_Keycode.SDLK_KP_VERTICALBAR,
            K_KP_DBLVERTICALBAR = SDL.SDL_Keycode.SDLK_KP_DBLVERTICALBAR,
            K_KP_COLON = SDL.SDL_Keycode.SDLK_KP_COLON,
            K_KP_HASH = SDL.SDL_Keycode.SDLK_KP_HASH,
            K_KP_SPACE = SDL.SDL_Keycode.SDLK_KP_SPACE,
            K_KP_AT = SDL.SDL_Keycode.SDLK_KP_AT,
            K_KP_EXCLAM = SDL.SDL_Keycode.SDLK_KP_EXCLAM,
            K_KP_MEMSTORE = SDL.SDL_Keycode.SDLK_KP_MEMSTORE,
            K_KP_MEMRECALL = SDL.SDL_Keycode.SDLK_KP_MEMRECALL,
            K_KP_MEMCLEAR = SDL.SDL_Keycode.SDLK_KP_MEMCLEAR,
            K_KP_MEMADD = SDL.SDL_Keycode.SDLK_KP_MEMADD,
            K_KP_MEMSUBTRACT = SDL.SDL_Keycode.SDLK_KP_MEMSUBTRACT,
            K_KP_MEMMULTIPLY = SDL.SDL_Keycode.SDLK_KP_MEMMULTIPLY,
            K_KP_MEMDIVIDE = SDL.SDL_Keycode.SDLK_KP_MEMDIVIDE,
            K_KP_PLUSMINUS = SDL.SDL_Keycode.SDLK_KP_PLUSMINUS,
            K_KP_CLEAR = SDL.SDL_Keycode.SDLK_KP_CLEAR,
            K_KP_CLEARENTRY = SDL.SDL_Keycode.SDLK_KP_CLEARENTRY,
            K_KP_BINARY = SDL.SDL_Keycode.SDLK_KP_BINARY,
            K_KP_OCTAL = SDL.SDL_Keycode.SDLK_KP_OCTAL,
            K_KP_DECIMAL = SDL.SDL_Keycode.SDLK_KP_DECIMAL,
            K_KP_HEXADECIMAL = SDL.SDL_Keycode.SDLK_KP_HEXADECIMAL,

            K_LCTRL = SDL.SDL_Keycode.SDLK_LCTRL,
            K_LSHIFT = SDL.SDL_Keycode.SDLK_LSHIFT,
            K_LALT = SDL.SDL_Keycode.SDLK_LALT,
            K_LGUI = SDL.SDL_Keycode.SDLK_LGUI,
            K_RCTRL = SDL.SDL_Keycode.SDLK_RCTRL,
            K_RSHIFT = SDL.SDL_Keycode.SDLK_RSHIFT,
            K_RALT = SDL.SDL_Keycode.SDLK_RALT,
            K_RGUI = SDL.SDL_Keycode.SDLK_RGUI,

            K_MODE = SDL.SDL_Keycode.SDLK_MODE,

            K_AUDIONEXT = SDL.SDL_Keycode.SDLK_AUDIONEXT,
            K_AUDIOPREV = SDL.SDL_Keycode.SDLK_AUDIOPREV,
            K_AUDIOSTOP = SDL.SDL_Keycode.SDLK_AUDIOSTOP,
            K_AUDIOPLAY = SDL.SDL_Keycode.SDLK_AUDIOPLAY,
            K_AUDIOMUTE = SDL.SDL_Keycode.SDLK_AUDIOMUTE,
            K_MEDIASELECT = SDL.SDL_Keycode.SDLK_MEDIASELECT,
            K_WWW = SDL.SDL_Keycode.SDLK_WWW,
            K_MAIL = SDL.SDL_Keycode.SDLK_MAIL,
            K_CALCULATOR = SDL.SDL_Keycode.SDLK_CALCULATOR,
            K_COMPUTER = SDL.SDL_Keycode.SDLK_COMPUTER,
            K_AC_SEARCH = SDL.SDL_Keycode.SDLK_AC_SEARCH,
            K_AC_HOME = SDL.SDL_Keycode.SDLK_AC_HOME,
            K_AC_BACK = SDL.SDL_Keycode.SDLK_AC_BACK,
            K_AC_FORWARD = SDL.SDL_Keycode.SDLK_AC_FORWARD,
            K_AC_STOP = SDL.SDL_Keycode.SDLK_AC_STOP,
            K_AC_REFRESH = SDL.SDL_Keycode.SDLK_AC_REFRESH,
            K_AC_BOOKMARKS = SDL.SDL_Keycode.SDLK_AC_BOOKMARKS,

            K_BRIGHTNESSDOWN = SDL.SDL_Keycode.SDLK_BRIGHTNESSDOWN,
            K_BRIGHTNESSUP = SDL.SDL_Keycode.SDLK_BRIGHTNESSUP,
            K_DISPLAYSWITCH = SDL.SDL_Keycode.SDLK_DISPLAYSWITCH,
            K_KBDILLUMTOGGLE = SDL.SDL_Keycode.SDLK_KBDILLUMTOGGLE,
            K_KBDILLUMDOWN = SDL.SDL_Keycode.SDLK_KBDILLUMDOWN,
            K_KBDILLUMUP = SDL.SDL_Keycode.SDLK_KBDILLUMUP,
            K_EJECT = SDL.SDL_Keycode.SDLK_EJECT,
            K_SLEEP = SDL.SDL_Keycode.SDLK_SLEEP,
            K_APP1 = SDL.SDL_Keycode.SDLK_APP1,
            K_APP2 = SDL.SDL_Keycode.SDLK_APP2,

            K_AUDIOREWIND = SDL.SDL_Keycode.SDLK_AUDIOREWIND,
            K_AUDIOFASTFORWARD = SDL.SDL_Keycode.SDLK_AUDIOFASTFORWARD
    }
}