using System;
using SlatedGameToolkit.Framework.Graphics.Programs;
using SlatedGameToolkit.Framework.Graphics.Render;
using SlatedGameToolkit.Framework.Graphics.Shaders;
using SlatedGameToolkit.Framework.Graphics.Textures;
using SlatedGameToolkit.Framework.Graphics.Window;
using SlatedGameToolkit.Framework.StateSystem;
using SlatedGameToolkit.Framework.StateSystem.States;

namespace SlatedGameToolkit.Tools.Utilities.GraphicalPlayground
{
    public class MainState : IState
    {
        private WindowContext window;
        private Renderer renderer;
        private Sprite2D sprite;

        public WindowContext CurrentWindow { get { return window;}}

        public bool Activate()
        {
            return true;
        }

        public bool Deactivate()
        {
            return true;
        }

        public void Deinitialize()
        {
            window.Dispose();
        }

        public string getName()
        {
            return "main state";
        }

        public void Initialize(Manager manager)
        {
            window = new WindowContext("SlatedGameToolkit Playground");
            renderer = new Renderer();
        }

        public void Render(double delta)
        {
        }

        public void Update(double delta)
        {
        }
    }
}